﻿import { propsConverter } from './routeUtils.js'

export default function getFormsRoutes()
{
	return [
		{
			path: '/:culture/:system/:module/form/AGENT/:mode/:id?',
			name: 'form-AGENT',
			props: route => propsConverter(route),
			component: () => import('@/views/forms/FormAgent/QFormAgent.vue'),
			meta: {
				routeType: 'form',
				baseArea: 'AGENT',
				humanKeyFields: ['ValName', 'ValEmail']
			}
		},
		{
			path: '/:culture/:system/:module/form/PROPERTY/:mode/:id?',
			name: 'form-PROPERTY',
			props: route => propsConverter(route),
			component: () => import('@/views/forms/FormProperty/QFormProperty.vue'),
			meta: {
				routeType: 'form',
				baseArea: 'PROPE',
				humanKeyFields: ['ValTitle']
			}
		},
	]
}
