﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Data;
using System.Data.Entity;
using System.Linq;

using CSGenio.business;
using CSGenio.framework;
using CSGenio.persistence;
using CSGenio.reporting;
using GenioMVC.Helpers;
using GenioMVC.Models;
using GenioMVC.Models.Exception;
using GenioMVC.Models.Navigation;
using GenioMVC.Resources;
using GenioServer.business;
using Quidgest.Persistence.GenericQuery;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Authorization;
using Microsoft.Extensions.Primitives;

// USE /[MANUAL SF3 INCLUDE_CONTROLLER S_ARG]/

namespace GenioMVC.Controllers
{
	public partial class S_argController : ControllerBase
	{
		public S_argController(UserContextService userContext): base(userContext) { }
// USE /[MANUAL SF3 CONTROLLER_NAVIGATION S_ARG]/



		private List<string> GetActionIds(CriteriaSet crs, CSGenio.persistence.PersistentSupport sp = null)
		{
			CSGenio.business.Area area = CSGenio.business.Area.createArea<CSGenioAs_arg>(UserContext.Current.User, UserContext.Current.User.CurrentModule);
			return base.GetActionIds(crs, sp, area);
		}

// USE /[MANUAL SF3 MANUAL_CONTROLLER S_ARG]/





		/// <summary>
		/// Get "See more..." tree structure
		/// </summary>
		/// <returns></returns>
		public JsonResult GetTreeSeeMore([FromBody]RequestLookupModel requestModel)
		{
			var Identifier = requestModel.Id;
			var queryParams = requestModel.QueryParams;

			try
			{
				// We need the request values to apply filters
				var requestValues = new NameValueCollection();
				if (queryParams != null)
					foreach (var kv in queryParams)
						requestValues.Add(kv.Key, kv.Value);

				switch (string.IsNullOrEmpty(Identifier) ? "" : Identifier)
				{
					default:
						break;
				}
			}
			catch (Exception)
			{
				return Json(new { Success = false, Message = "Error" });
			}

			return Json(new { Success = false, Message = "Error" });
		}

		public ActionResult GetDocumsTickets([FromBody]RequestDocumGetTicketsModel requestModel)
		{
			return base.GetDocumsTickets(requestModel.TableName, requestModel.FieldName, requestModel.KeyValue);
		}

		public ActionResult GetDocumsVersionsDBEdit([FromBody]RequestDocumTicketsModel requestModel)
		{
			return base.GetDocumsVersionsDBEdit(requestModel.Ticket);
		}

		public ActionResult GetFileProperties([FromBody]RequestDocumTicketsModel requestModel)
		{
			return base.GetFileProperties(requestModel.Ticket);
		}

		public ActionResult SubmitVersion([FromBody]RequestDocumTicketsModel requestModel)
		{
			return base.SubmitVersion(requestModel.Ticket);
		}

		public ActionResult CheckoutDocum([FromBody]RequestDocumTicketsModel requestModel)
		{
			return base.CheckoutDocum(requestModel.Ticket);
		}

		public ActionResult DeleteFile([FromBody]RequestDocumDeleteModel requestModel)
		{
			return base.DeleteFile(requestModel.Ticket, requestModel.Action);
		}

		public new ActionResult SetFile([FromForm] string ticket, [FromForm] ControllerBase.VersionSubmitAction mode = VersionSubmitAction.Insert, [FromForm] string version = "1")
		{
			return base.SetFile(ticket, mode, version);
		}

		public ActionResult GetFile([FromBody]RequestDocumTicketsModel requestModel)
		{
			return base.GetFile(requestModel.Ticket, requestModel.ViewType);
		}

		public ActionResult GetSpecificFile([FromBody]RequestDocumTicketsModel requestModel)
		{
			return base.GetSpecificFile(requestModel.Ticket);
		}
	}
}
