using System;
using CSGenio.framework;
using System.Collections;
using System.Collections.Generic;
using System.Data.SqlTypes;
using CSGenio.persistence;
using System.Text;
using Quidgest.Persistence;
using Quidgest.Persistence.GenericQuery;

namespace CSGenio.business
{
	/// <summary>
	/// Summary description for CSArea.
	/// </summary>
	public class CSGenioAlstusr : DbArea
	{
	    /// <summary>
		/// Meta-informao sobre esta rea
		/// </summary>
		protected static AreaInfo informacao = InicializaAreaInfo();

		public CSGenioAlstusr(User user,string module)
		{
			fields = new Hashtable();
            this.user = user;
            this.module = module;
		}
	
		public CSGenioAlstusr(User user) : this(user, user.CurrentModule)
		{
		}
	
		private static AreaInfo InicializaAreaInfo()
		{
			AreaInfo info = new AreaInfo();
			
			/*Information das areas*/
			info.TableName = "SF3lstusr";
			info.ShadowTabName = "";
			info.PrimaryKeyName = "codlstusr";
            info.HumanKeyName = "descric";
			info.ShadowTabKeyName = "";
			info.Alias = "lstusr";
			info.IsDomain =  false;
			info.AreaDesignation = "Lista de utilizador";
			info.AreaPluralDesignation = "Listas de utilizadores";
			info.DescriptionCav = "Lista de utilizador";
			
			//sincronizao
			info.SyncIncrementalDateStart = TimeSpan.FromHours(9.0);
			info.SyncIncrementalDateEnd = TimeSpan.FromHours(23.0);
			info.SyncCompleteHour = TimeSpan.FromHours(1.0);
			info.SyncIncrementalPeriod = TimeSpan.FromHours(1);
			info.BatchSync = 100;
			info.SyncType = SyncType.Central;
					
			info.RegisterFieldDB(new Field("codlstusr", FieldType.CHAVE_PRIMARIA));
			info.DBFields["codlstusr"].FieldSize = 6;
			info.RegisterFieldDB(new Field("codpsw", FieldType.CHAVE_ESTRANGEIRA));
			info.DBFields["codpsw"].FieldSize = 8;
			info.KeyType = CodeType.INT_KEY;
			info.RegisterFieldDB(new Field("idlist", FieldType.TEXTO));
			info.RegisterFieldDB(new Field("descric", FieldType.TEXTO));
            info.RegisterFieldDB(new Field("modulo", FieldType.TEXTO));
            info.RegisterFieldDB(new Field("sistema", FieldType.TEXTO));
            info.RegisterFieldDB(new Field("ordercol", FieldType.INTEIRO));
            info.RegisterFieldDB(new Field("ordertype", FieldType.INTEIRO));
            info.RegisterFieldDB(new Field("data", FieldType.DATACRIA));
            info.RegisterFieldDB(new Field("zzstate", FieldType.INTEIRO));

            // Carimbos automticos na BD
            //------------------------------
   			info.StampFieldsIns = new string[] {
             "data"
			};

			// Relaes Filhas
			//------------------------------

			// Relaes Me
			//------------------------------

			// Pathways
			//------------------------------

			// Levels de acesso
			//------------------------------
			info.QLevel = new QLevel();
			info.QLevel.Query = Role.UNAUTHORIZED;
			info.QLevel.Create = Role.UNAUTHORIZED;
			info.QLevel.AlterAlways = Role.UNAUTHORIZED;
			info.QLevel.RemoveAlways = Role.UNAUTHORIZED;

			// Automatic audit stamps in BD
            //------------------------------


			return info;
		}
		
		/// <summary>
		/// Meta-informao sobre esta rea
		/// </summary>
		public override AreaInfo Information
		{
			get { return informacao; }
		}
		/// <summary>
		/// Meta-informao sobre esta rea
		/// </summary>		
		public static AreaInfo GetInformation()
		{
			return informacao;
		}

		// USE /[MANUAL SF3 TABAUX lstusr]/

		
        public string FormMode { get; set; }
        public string ResultMsg { get; set; }

        ////////////////////////////////////////////////////////////////////////////BD fields CONVERTED TO Areainfo style
        /// <summary>Campo : "PK da tabela lstusr" Tipo: "+" Formula:  ""</summary>
        public static FieldRef FldCodlstusr { get { return m_fldCodlstusr; } }
        private static FieldRef m_fldCodlstusr = new FieldRef("lstusr", "codlstusr");

        /// <summary>Campo : "PK da tabela lstusr" Tipo: "+" Formula:  ""</summary>
        public string ValCodlstusr
        {
            get { return (string)returnValueField(FldCodlstusr); }
            set { insertNameValueField(FldCodlstusr, value); }
        }

        /// <summary>Campo : "PK da tabela psw" Tipo: "+" Formula:  ""</summary>
        public static FieldRef FldCodpsw { get { return m_fldCodpsw; } }
        private static FieldRef m_fldCodpsw = new FieldRef("lstusr", "codpsw");

        /// <summary>Campo : "PK da tabela psw" Tipo: "+" Formula:  ""</summary>
        public string ValCodpsw
        {
            get { return (string)returnValueField(FldCodpsw); }
            set { insertNameValueField(FldCodpsw, value); }
        }

        /// <summary>Campo : "Nome da lista" Tipo: "C" Formula:  ""</summary>
        public static FieldRef FldDescric { get { return m_fldDescric; } }
        private static FieldRef m_fldDescric = new FieldRef("lstusr", "descric");

        /// <summary>Campo : "Nome da lista" Tipo: "C" Formula:  ""</summary>
        public string ValDescric
        {
            get { return (string)returnValueField(FldDescric); }
            set { insertNameValueField(FldDescric, value); }
        }

        /// <summary>Campo : "ID da lista" Tipo: "C" Formula:  ""</summary>
        public static FieldRef FldIdlist { get { return m_fldIdlist; } }
        private static FieldRef m_fldIdlist = new FieldRef("lstusr", "idlist");

        /// <summary>Campo : "ID da lista" Tipo: "C" Formula:  ""</summary>
        public string ValIdlist
        {
            get { return (string)returnValueField(FldIdlist); }
            set { insertNameValueField(FldIdlist, value); }
        }

        /// <summary>Campo : "Mdulo" Tipo: "C" Formula:  ""</summary>
        public static FieldRef FldModulo { get { return m_fldModulo; } }
        private static FieldRef m_fldModulo = new FieldRef("lstusr", "modulo");

        /// <summary>Campo : "Mdulo" Tipo: "C" Formula:  ""</summary>
        public string ValModulo
        {
            get { return (string)returnValueField(FldModulo); }
            set { insertNameValueField(FldModulo, value); }
        }

        /// <summary>Campo : "Sistema" Tipo: "C" Formula:  ""</summary>
        public static FieldRef FldSistema { get { return m_fldSistema; } }
        private static FieldRef m_fldSistema = new FieldRef("lstusr", "sistema");

        /// <summary>Campo : "Sistema" Tipo: "C" Formula:  ""</summary>
        public string ValSistema
        {
            get { return (string)returnValueField(FldSistema); }
            set { insertNameValueField(FldSistema, value); }
        }

        /// <summary>Campo : "Coluna de ordenao" Tipo: "N" Formula:  ""</summary>
        public static FieldRef FldOrdercol { get { return m_fldOrdercol; } }
        private static FieldRef m_fldOrdercol = new FieldRef("lstusr", "ordercol");

        /// <summary>Campo : "Coluna de ordenao" Tipo: "N" Formula:  ""</summary>
        public int ValOrdercol
        {
            get { return (int)returnValueField(FldOrdercol); }
            set { insertNameValueField(FldOrdercol, value); }
        }

        /// <summary>Campo : "Tipo de ordenao" Tipo: "N" Formula:  ""</summary>
        public static FieldRef FldOrdertype { get { return m_fldOrdertype; } }
        private static FieldRef m_fldOrdertype = new FieldRef("lstusr", "ordertype");

        /// <summary>Campo : "Tipo de ordenao" Tipo: "N" Formula:  ""</summary>
        public int ValOrdertype
        {
            get { return (int)returnValueField(FldOrdertype); }
            set { insertNameValueField(FldOrdertype, value); }
        }


        /// <summary>Campo : "Criao: Data" Tipo: "OD" Formula:  ""</summary>
        public static FieldRef FldData { get { return m_fldData; } }
        private static FieldRef m_fldData = new FieldRef("lstusr", "data");

        /// <summary>Campo : "Criao: Data" Tipo: "OD" Formula:  ""</summary>
        public DateTime ValData
        {
            get { return (DateTime)returnValueField(FldData); }
            set { insertNameValueField(FldData, value); }
        }

        /// <summary>Campo : "ZZSTATE" Tipo: "INT" Formula:  ""</summary>
        public static FieldRef FldZzstate { get { return m_fldZzstate; } }
        private static FieldRef m_fldZzstate = new FieldRef("lstusr", "zzstate");

        /// <summary>Campo : "ZZSTATE" Tipo: "INT"</summary>
        public int ValZzstate
        {
            get { return (int)returnValueField(FldZzstate); }
            set { insertNameValueField(FldZzstate, value); }
        }


        /// <summary>
        /// Obtains a partially populated area with the record corresponding to a primary key
        /// </summary>
        /// <param name="sp">Persistent support from where to get the registration</param>
        /// <param name="key">The value of the primary key</param>
        /// <param name="user">The context of the user</param>
        /// <param name="fields">The fields to be filled in the area</param>
        /// <returns>An area with the fields requests of the record read or null if the key does not exist</returns>
        /// <remarks>Persistence operations should not be used on a partially positioned register</remarks>
		public static CSGenioAlstusr search(PersistentSupport sp, string key, User user, string[] fields = null)
        {
            if (string.IsNullOrEmpty(key)) //para proteger chamadas "cegas"
                return null;
            CSGenioAlstusr area = new CSGenioAlstusr(user, user.CurrentModule);
            if (sp.getRecord(area, key, fields))
                return area;
            return null;
        }

        /// <summary>
        /// Procura todos os registos desta area que obedecem a uma condio
        /// </summary>
        /// <param name="sp">O suporte persistente de onde obter a lista</param>
        /// <param name="User">O contexto do User</param>
        /// <param name="where">A condio de procura dos registos. Usar null para obter todos os registos</param>
        /// <returns>Uma lista de registos da areas com todos os campos preenchidos</returns>
        public static List<CSGenioAlstusr> searchList(PersistentSupport sp, User User, CriteriaSet where)
        {
            return searchList(sp, User, where, null);
        }
   
        /// <summary>
        /// Procura todos os registos desta area que obedecem a uma condio
        /// </summary>
        /// <param name="sp">O suporte persistente de onde obter a lista</param>
        /// <param name="User">O contexto do User</param>
        /// <param name="where">A condio de procura dos registos. Usar null para obter todos os registos</param>
        /// <param name="campos">Os campos a serem preenchidos na area</param>
        /// <returns>Uma lista de registos da areas com todos os campos preenchidos</returns>
        /// <remarks>No devem ser utilizadas operaes de persistence sobre um registo parcialmente posicionado</remarks>
        public static List<CSGenioAlstusr> searchList(PersistentSupport sp, User User, CriteriaSet where, string[] campos)
        {
            return sp.searchListWhere<CSGenioAlstusr>(where, User, campos);
        }
		
        /// <summary>
        /// Procura todos os registos desta area que obedecem a uma condio
        /// </summary>
        /// <param name="sp">O suporte persistente de onde obter a lista</param>
        /// <param name="User">O contexto do User</param>
        /// <param name="where">A condio de procura dos registos. Usar null para obter todos os registos</param>
        /// <param name="campos">Os campos a serem preenchidos na area</param>
        /// <param name="distinct">Obter distinct de campos</param>
        /// <param name="noLock">NOLOCK</param>
        /// <returns>Uma lista de registos da areas com todos os campos preenchidos</returns>
        /// <remarks>No devem ser utilizadas operaes de persistence sobre um registo parcialmente posicionado</remarks>
		public static void searchListAdvancedWhere(PersistentSupport sp, User User, CriteriaSet where, ListingMVC<CSGenioAlstusr> listing)
        {
            sp.searchListAdvancedWhere<CSGenioAlstusr>(where, listing);
        }
		
        /// <summary>
        /// Procura todos os registos desta area que obedecem a uma condio
        /// </summary>
        /// <param name="sp">O suporte persistente de onde obter a lista</param>
        /// <param name="User">O contexto do User</param>
        /// <param name="where">A condio de procura dos registos. Usar null para obter todos os registos</param>
        /// <param name="campos">Os campos a serem preenchidos na area</param>
        /// <param name="distinct">Obter distinct de campos</param>
        /// <param name="noLock">NOLOCK</param>
        /// <returns>Uma lista de registos da areas com todos os campos preenchidos</returns>
        /// <remarks>No devem ser utilizadas operaes de persistence sobre um registo parcialmente posicionado</remarks>
        public static List<CSGenioAlstusr> searchList(PersistentSupport sp, User User, CriteriaSet where, string[] campos, bool distinct, bool noLock = false)
        {
            return sp.searchListWhere<CSGenioAlstusr>(where, User, campos, distinct, noLock);
        }

        /// <summary>
        /// Procura todos os registos desta area que obedecem a uma condio
        /// </summary>
        /// <param name="sp">O suporte persistente de onde obter a lista</param>
        /// <param name="User">O contexto do User</param>
        /// <param name="where">A condio de procura dos registos. Usar null para obter todos os registos</param>
        /// <param name="campos">Os campos a serem preenchidos na area</param>
        /// <param name="distinct">Obter distinct de campos</param>
        /// <returns>Uma lista de registos da areas com todos os campos preenchidos</returns>
        /// <remarks>No devem ser utilizadas operaes de persistence sobre um registo parcialmente posicionado</remarks>
		public static List<CSGenioAlstusr> searchList(PersistentSupport sp, User User, CriteriaSet where, bool distinct, bool noLock = false)
        {
            return searchList(sp, User, where, null, distinct, noLock);
        }

	}
}
